#pragma once
#include <windows.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#pragma pack(1)
typedef struct
{
	short start_vert;
	short end_vert;
	short flags;
	short special;
	short sector;
	short right_sidedef;
	short left_sidedef;
} linedef_t;
#pragma pack(8)

#pragma pack(1)
typedef struct
{
	short x;
	short y;
	short angle;
	short type;
	short flags;
} thing_t;
#pragma pack(8)

#pragma pack(1)
typedef struct
{
	short x;
	short y;
} vert_t;
#pragma pack(8)

#pragma pack(1)
typedef struct
{
	short tex_xoffset;
	short tex_yoffset;
	char tex_upper[8];
	char tex_lower[8];
	char tex_middle[8];
	short sector;
} sidedef_t;
#pragma pack(8)

#pragma pack(1)
typedef struct
{
	short floor_height;
	short ceil_height;
	char tex_floor[8];
	short light_level;
	short type;
	short tag;
} sector_t;
#pragma pack(8)

#pragma pack(1)
typedef struct
{
	short start_vert;
	short end_vert;
	short angle;
	short linedef;
	short dir;
	short offset;
} seg_t;
#pragma pack(8)

#pragma pack(1)
typedef struct
{
	short count;
	short first;
} subsector_t;
#pragma pack(8)

#pragma pack(1)
typedef struct
{
	short x;
	short y;
	short dx;
	short dy;
	short right_bbox[4];
	short left_bbox[4];
	short right;
	short left;
} node_t;
#pragma pack(8)

typedef struct
{
	vert_t *pvert;
	int num_vert;
	linedef_t *pline;
	int num_line;
	thing_t *pthing;
	int num_thing;
	sidedef_t *pside;
	int num_side;
	sector_t *psector;
	int num_sector;
	seg_t *pseg;
	int num_seg;
	subsector_t *psubsector;
	int num_subsector;
	node_t *pnode;
	int num_node;
} waddata_t;



char *get_file(char *filename, unsigned int *size);
void *get_wadfile(char *wadfile, char *level, char *lump, int *lump_size, char **pdata);